import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;

/**
   Creates a simple demonstration of drawing custom graphics
   on a component.  This class demonstrates the
   synchronization problems that occur if you change the
   component'state of the component's graphics related
   parameters after obtaining a graphics object in which to
   draw.
*/
class GraphicsSyncDemo extends Panel
{
  /**
     Paints (renders) a string on the component. 

     @param g the Graphics context in which the painting is done.
  */
  public void paint(Graphics g)
  {
    // Change the state of the component.  This will not
    // affect the graphics object passed in to this method,
    // which was configured with information from the
    // component BEFORE the call.
    //
    setFont(new Font("sansserif", Font.ITALIC, 12));

//     g.setFont(new Font("sansserif", Font.PLAIN, 16));
    g.drawString("Our first attempt at drawing Graphics", 
		 20, 150);
  }


  /**
     Specifies the preferred size of this component.

     @return the component's preferred screen size.
  */
  public Dimension getPreferredSize()
  {
    return new Dimension(300, 300);
  }

  
  public static void main(String [] args)
  {
    GraphicsSyncDemo app = new GraphicsSyncDemo();
    JFrame f = new JFrame("Graphics Synchronization Demo");
    WindowListener wl = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    e.getWindow().dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wl);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }
}
