import java.awt.*;
import com.sun.java.swing.*;

/**

 */
class LightVersusHeavy extends JPanel
{
  public LightVersusHeavy()
  {
    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints gbc = new GridBagConstraints();

    setLayout(gbl);
    
    Label heavyweightLabel = new Label("Heavyweight Label");
    gbl.setConstraints(heavyweightLabel, gbc);

    // Create a lightweight label (Swing label) and add it to 
    // the main panel. 
    JLabel lightweightLabel = new JLabel("Lightweight Label");
    gbc.gridx = 0;
    gbc.gridy = 1;
    gbc.insets = new Insets(5, 10, 5, 10);
    gbc.anchor = GridBagConstraints.CENTER;
    gbl.setConstraints(lightweightLabel, gbc);
    
    Button heavyweightButton = new Button("Heavyweight Button");
    gbc.gridx = 1;
    gbc.gridy = 0;
    gbl.setConstraints(heavyweightButton, gbc);

    JButton lightweightButton = new JButton("Lightweight Button");
    gbc.gridx = 1;
    gbc.gridy = 1;
    gbl.setConstraints(lightweightButton, gbc);

    add(heavyweightLabel);
    add(lightweightLabel);

    add(heavyweightButton);
    add(lightweightButton);
  }


  public Dimension getPreferredSize()
  {
    return new Dimension(300, 150);
  }


  public static void main(String [] args)
  {
    Frame f = new Frame("Lightweight versus Heavyweight Components");

    LightVersusHeavy app = new LightVersusHeavy();
    f.add(app);
    f.pack();
    f.setVisible(true);
  }

}
