import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
   This class demonstrates the use of Swing buttons.
*/
public class Buttons extends JPanel
{
  /**
     No-arg constructor.
  */
  public Buttons()
  {
    // A normal button with mnemonic key "N".
    //
    JButton b0 = new JButton("Button With No Icon");
    b0.setMnemonic('N');

    // A button with an icon placed to the right of the button text.
    //
    JButton b1 = new JButton("Button With Icon");
    b1.setHorizontalTextPosition(AbstractButton.LEFT);

    // Set the button's icon.
    //
    Icon alarm = new ImageIcon("/home/vartan/dev/book/ch7/alrm_critic.gif");
    b1.setIcon(alarm);
    b1.setMnemonic('I');
    b1.setFocusPainted(true);

    // A disabled button with an icon placed above the button text.
    // 
    JButton b2 = new JButton("Disabled Button");
    b2.setVerticalTextPosition(AbstractButton.BOTTOM);
    b2.setHorizontalTextPosition(AbstractButton.CENTER);

    // Set the icon normally displayed.
    //
    b2.setIcon(new ImageIcon("/home/vartan/dev/book/ch7/alrm_minor.gif"));

    // Set the icon displayed when the button is in the disabled state.
    //
    b2.setDisabledIcon(new
         ImageIcon("/home/vartan/dev/book/ch7/alrm_warn.gif"));

    // Set the icon displayed when the button is in the disabled
    // selected state.
    //
    b2.setDisabledSelectedIcon(new
         ImageIcon("/home/vartan/dev/book/ch7/alrm_warn_norm.gif"));
    b2.setMnemonic('D');
    b2.setEnabled(false);

    // A rollover button.  This button has two images.  The first is
    // usually displayed; the second is displayed when the mouse is
    // rolled over the button.
    //
    JButton b3 = new JButton("Rollover Button");

    // Set the normal icon.
    //
    b3.setIcon(new ImageIcon("/home/vartan/dev/book/ch7/alrm_warn.gif"));
    b3.setRolloverEnabled(true);
    b3.setVerticalTextPosition(AbstractButton.BOTTOM);

    // Set the rollover icon.
    //
    b3.setRolloverIcon(new 
        ImageIcon("/home/vartan/dev/book/ch7/alrm_warn_norm.gif"));
    b3.setMnemonic('R');

    add(b0);
    add(b1);
    add(b2);
    add(b3);
  }

  public static void main(String [] args)
  {
    Buttons app = new Buttons();

    JFrame f = new JFrame("JButton Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

}
