import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;

/**
   This class demonstrates the use of the Swing file chooser.
*/
public class FileChoose extends JPanel
{
  public FileChoose()
  {
    // Create a file chooser. Specify the directory whose contents
    // should be displayed by the file chooser.
    //
    JFileChooser fc = new JFileChooser(new File("/usr/local"));

    // Set the font for displaying the file names.
    //
    fc.setFont(new Font("SansSerif", Font.PLAIN, 14));

    Box box = Box.createVerticalBox();

    box.add(Box.createRigidArea(new Dimension(0, 10)));
    box.add(fc);
    
    add(box);
  }

  public static void main(String [] args)
  {
    FileChoose app = new FileChoose();

    JFrame f = new JFrame("JFileChooser Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

}
