import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
   This class demonstrates use of Swing lists.
*/
public class Lists extends JPanel
{
  /**
     No-arg constructor.
  */
  public Lists()
  {
    Font f14 = new Font("SansSerif", Font.PLAIN, 14);
    Dimension dim = new Dimension(0, 10);

    // The set of strings used to populate the leftmost list.
    //
    String [] philosophers = {"Aristotle", "Confucius", "Laotze", 
			      "Pascal", "Plato", "Rousseau", 
			      "Socrates", ""};

    String [] painters = {"Michelangelo", "Rembrandt", "Renoir", 
			  "da Vinci", "van Gogh", "Monet", "Manet",
			  "Picasso"};

    String [] mathematicians = {"Abel", "Chebyshev", "Dirichlet", 
				"Fourier", "Lagrange", "Galois", 
				"Gauss", "Laplace", "Landau"};

    JList singleSelectionList = new JList();
    singleSelectionList.setVisibleRowCount(7);
    singleSelectionList.setFont(f14);
    singleSelectionList.setAlignmentX(Component.LEFT_ALIGNMENT);
    singleSelectionList.setListData(philosophers);
    singleSelectionList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    JScrollPane ssPane = new JScrollPane(singleSelectionList);
    ssPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

    Box singleSelectionBox = Box.createVerticalBox();

    JLabel singleSelectionLabel = new JLabel("Single Selection List");
    singleSelectionLabel.setAlignmentX(Component.LEFT_ALIGNMENT);

    singleSelectionBox.add(singleSelectionLabel);
    singleSelectionBox.add(Box.createRigidArea(dim));
    singleSelectionBox.add(ssPane);

    JList singleIntervalList = new JList();
    singleIntervalList.setVisibleRowCount(7);
    singleIntervalList.setAlignmentX(Component.LEFT_ALIGNMENT);
    singleIntervalList.setFont(f14);
    singleIntervalList.setListData(painters);
    singleIntervalList.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);

    Box singleIntervalBox = Box.createVerticalBox();

    JLabel singleIntervalLabel = new JLabel("Single Interval List");
    singleIntervalLabel.setAlignmentX(Component.LEFT_ALIGNMENT);

    singleIntervalBox.add(singleIntervalLabel);
    singleIntervalBox.add(Box.createRigidArea(dim));
    singleIntervalBox.add(new JScrollPane(singleIntervalList));

    JList multipleIntervalList = new JList();
    multipleIntervalList.setVisibleRowCount(7);
    multipleIntervalList.setAlignmentX(Component.LEFT_ALIGNMENT);
    multipleIntervalList.setFont(f14);
    multipleIntervalList.setListData(mathematicians);
    multipleIntervalList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
    multipleIntervalList.addSelectionInterval(0, 2);
    multipleIntervalList.addSelectionInterval(4, 5);

    Box multipleIntervalBox =  Box.createVerticalBox();

    JLabel multipleIntervalLabel = new JLabel("Multiple Interval List");
    multipleIntervalLabel.setAlignmentX(Component.LEFT_ALIGNMENT);

    multipleIntervalBox.add(multipleIntervalLabel);
    multipleIntervalBox.add(Box.createRigidArea(dim));
    multipleIntervalBox.add(new JScrollPane(multipleIntervalList));
    
    Box mainBox = Box.createHorizontalBox();

    mainBox.add(singleSelectionBox);
    mainBox.add(Box.createHorizontalStrut(20));
    mainBox.add(singleIntervalBox);
    mainBox.add(Box.createHorizontalStrut(20));
    mainBox.add(multipleIntervalBox);

    add(mainBox);
  }

  public static void main(String [] args)
  {
    Lists app = new Lists();

    JFrame f = new JFrame("JList Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

}
