import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
   This class demonstrates use of the Swing password field.  Password
   fields are text fields that support an echo character, which is a
   character rendered in place of the actual character typed by the
   user.
*/
class PasswordDemo extends JPanel
{
  /**
     No-arg constructor.
  */
  public PasswordDemo()
  {
    Box box = Box.createVerticalBox();

    Font f14 = new Font("SansSerif", Font.PLAIN, 14);
    Dimension dim = new Dimension(300, 30);

    // Create a password field.  Specify the echo character to be
    // the "#" character, which will be rendered in the password
    // field whenever the user types a key.
    //
    JPasswordField pw1 = new JPasswordField();
    pw1.setPreferredSize(dim);
    pw1.setEchoChar('#');

    // Create another text field which uses the default echo
    // character.  The default echo character is the "*".
    //
    JPasswordField pw2 = new JPasswordField();
    pw2.setText("This is right-aligned text.");
    pw2.setPreferredSize(dim);

    box.add(pw1);
    box.add(pw2);

    add(box);
  }


  public static void main(String [] args)
  {
    PasswordDemo app = new PasswordDemo();

    JFrame f = new JFrame("Password Field Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }
}
