import java.awt.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;

class Tables extends JPanel
{

  public Tables()
  {
    String [] jobs = {"Engineer", "Psychologist", "Rocket Scientist",
		      "Stock Broker", "Doctor", "Chef"};

    JList occupations = new JList(jobs);

    Object [][] tableData = 
    { 
      {"Vartan", "Los Angeles, Ca.", "Engineer", new Boolean(true)},
      {"Lisa", "Boston, Ma.", "Psychologist", new Boolean(true)},
      {"Fred", "Los Angeles, Ca.", "Stock Broker", new Boolean(true)}
    };

    Object [] colNames = {"Name", "Place of Birth", "Occupation", "Employed"};

    Vector columnNames = new Vector();
    columnNames.addElement("Name");
    columnNames.addElement("Place of Birth");
    columnNames.addElement("Occupation");
    columnNames.addElement("Employed");

    class DemoTableModel extends AbstractTableModel
    {
      final String [] columnNames = {"Name", "Place of Birth", 
				     "Occupation", "Employed"};

      final Object [][] data = 
      {
	{"Vartan", "Los Angeles, Ca.", "Engineer", new Boolean(true)},
	{"Lisa", "Boston, Ma.", "Psychologist", new Boolean(true)},
	{"Fred", "Los Angeles, Ca.", "Stock Broker", new Boolean(true)},
	{"Mom", "Boston, Ma.", "Homemaker", new Boolean(true)}
      };

      public int getColumnCount() {
	return columnNames.length;
      }
        
      public int getRowCount() {
	return data.length;
      }

      public String getColumnName(int col) {
	return columnNames[col];
      }

      public Object getValueAt(int row, int col) {
	return data[row][col];
      }

      public Class getColumnClass(int c) {
	return getValueAt(0, c).getClass();
      }

    }
	

    JTable table = new JTable(tableData, colNames);
    table.setPreferredScrollableViewportSize(new Dimension(500, 50));

    JScrollPane scrollPane = new JScrollPane(table);

    add(table.getTableHeader(), BorderLayout.NORTH);
    add(scrollPane, BorderLayout.CENTER);

  }


  public static void main(String [] args)
  {
    JFrame f = new JFrame("Tables Demo");

    Tables app = new Tables();

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }
}
