import java.awt.*;
import javax.swing.*;

public class BoxLayoutDemo extends JPanel
{
  public BoxLayoutDemo()
  {
    setLayout(new BorderLayout());

    // Create the panel that holds buttons 1, 2, and 3.
    // This container will have a horizontal layout.
    //
    JPanel oneToThree = new JPanel();
    BoxLayout box_1_3_Layout = new BoxLayout(oneToThree, BoxLayout.X_AXIS);
    oneToThree.setLayout(box_1_3_Layout);

    // Add the buttons to the container.
    //
    oneToThree.add(new JButton("1"));
    oneToThree.add(new JButton("2"));
    oneToThree.add(new JButton("3"));
    
    // Create the panel that holds buttons 4, 5, and 6.
    // This container will have  horizontal layout too.
    //
    JPanel fourToSix = new JPanel();
    BoxLayout box_4_6_Layout = new BoxLayout(fourToSix, BoxLayout.X_AXIS);
    fourToSix.setLayout(box_4_6_Layout);

    // Add the buttons to the container.
    //
    fourToSix.add(new JButton("4"));
    fourToSix.add(new JButton("5"));
    fourToSix.add(new JButton("6"));

    // Create the panel that holds the buttons 7, 8, and 9.
    // It also has a horizontal layout.
    //
    JPanel sevenToNine = new JPanel();
    BoxLayout box_7_9_Layout = new BoxLayout(sevenToNine, BoxLayout.X_AXIS);
    sevenToNine.setLayout(box_7_9_Layout);

    // Add the buttons to the container.
    //
    sevenToNine.add(new JButton("7"));
    sevenToNine.add(new JButton("8"));
    sevenToNine.add(new JButton("9"));

    // Create the panel that will hold the first three panels.
    // We are nesting panels here.
    // Notice that this panel uses a vertical layout (Y_AXIS).
    // It places the other three panels in one vertical column.
    //
    JPanel intermediatePanel = new JPanel();
    BoxLayout intermediateLayout = new BoxLayout(intermediatePanel, 
						 BoxLayout.Y_AXIS);

    intermediatePanel.setLayout(intermediateLayout);

    // Add the nested panels to the intermediate panel.
    //
    intermediatePanel.add(oneToThree);
    intermediatePanel.add(fourToSix);
    intermediatePanel.add(sevenToNine);

    // Added to the CENTER of our BorderLayout by default.
    //
    add(intermediatePanel);

  }

  public static void main(String [] args)
  {
    BoxLayoutDemo app = new BoxLayoutDemo();

    JFrame f = new JFrame("BoxLayout Demo");
    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

}
