import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;


public class CaretEventDemo extends JPanel
{
  public CaretEventDemo()
  {
    String str = "What happens when we modify this text?";
    JTextField textField = new JTextField(str, 25);
    textField.setFont(new Font("SansSerif", Font.PLAIN, 14));

    CaretListener cL = new CaretMonitor();

    // Add a listener for CaretEvents.  
    textField.addCaretListener(cL);

    add(textField);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(390, 110);
  }

  public static void main(String [] args)
  {
    CaretEventDemo app = new CaretEventDemo();

    JFrame f = new JFrame("Caret Event Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    e.getWindow().dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);
    
    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }


}


class CaretMonitor implements CaretListener
{
  public void caretUpdate(CaretEvent e)
  {
    System.out.println("The mark is at position " + e.getMark());
    System.out.println("The dot is at position " + e.getDot());
    System.out.println();
  }

}



