import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class FocusEventDemo extends JPanel 
{
  public FocusEventDemo()
  {
    JButton b1 = new JButton("Button 1");
    JButton b2 = new JButton("Button 2");

    FocusMonitor fL = new FocusMonitor();
    b1.addFocusListener(fL);
    b2.addFocusListener(fL);

    add(b1);
    add(b2);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(300, 80);
  }

  public static void main(String [] args)
  {
    FocusEventDemo app = new FocusEventDemo();

    JFrame f = new JFrame("Focus Event Demo");
    WindowListener wl = new WindowAdapter() 
      {
	public void windowClosing(WindowEvent e) 
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wl);
    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

  JLabel label;
}


class FocusMonitor implements FocusListener
{
  public void focusGained(FocusEvent e)
  {
    Component c = (Component) e.getSource();
    System.out.print("Focus gained.  " + ((JButton) c).getText());

    if (e.isTemporary())
      System.out.print("  temporarily");
    System.out.println();
  }
   
  public void focusLost(FocusEvent e)
  {
    Component c = (Component) e.getSource();
    System.out.print("Focus lost.  " + ((JButton) c).getText());

    if (e.isTemporary())
      System.out.print("  temporarily");
    System.out.println();
  }
}


