import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class ItemEventDemo extends JPanel 
{
  public ItemEventDemo()
  {
    String [] grocery = {"Eggs", "Milk", "Chicken", "Endive lettuce",
		 "Vegetables", "Peanut butter", "Orange juice",
		 "Apples", "Bananas", "Yogurt", "Cottage cheese",
		 "Bread", "Tuna fish", "Spices"};

    JComboBox cb = new JComboBox(grocery);
    cb.setEditable(true);
    cb.setAlignmentX(Component.LEFT_ALIGNMENT);
    cb.setMaximumRowCount(20);
    cb.setSelectedIndex(8);

    ItemMonitor iL = new ItemMonitor();
    cb.addItemListener(iL);

    add(cb);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(200, 250);
  }

  public static void main(String [] args)
  {
    ItemEventDemo app = new ItemEventDemo();

    JFrame f = new JFrame("Item Event Demo");

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }
}


class ItemMonitor implements ItemListener
{
  public void itemStateChanged(ItemEvent e) 
  {
    // Gets the source, just like EventObject.getSource. 
    JComboBox c = (JComboBox) e.getItemSelectable();
    
    if (e.getStateChange() == ItemEvent.SELECTED)
      System.out.println("Selection now = " + c.getSelectedItem().toString());
  }
}

