import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class KeyEventDemo extends JPanel 
{
  public KeyEventDemo()
  {
    JTextField textField = new JTextField(25);
    textField.setFont(new Font("SansSerif", Font.PLAIN, 14));

    KeyMonitor tL = new KeyMonitor();
    textField.addKeyListener(tL);

    add(textField);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(300, 80);
  }

  public static void main(String [] args)
  {
    KeyEventDemo app = new KeyEventDemo();

    JFrame f = new JFrame("Key Event Demo");
    WindowListener wl = new WindowAdapter() 
      {
	public void windowClosing(WindowEvent e) 
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wl);
    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

  JLabel label;
}


class KeyMonitor implements KeyListener
{
  public void keyPressed(KeyEvent e)
  {
    System.out.println("Key pressed...");
    printKeyEventInfo(e);
  }

  public void keyReleased(KeyEvent e)
  {
    System.out.println("Key released...");
    printKeyEventInfo(e);
  }

  public void keyTyped(KeyEvent e)
  {
    System.out.println("Key typed...");
    printKeyEventInfo(e);
  }
  
  private void printKeyEventInfo(KeyEvent e)
  {
    int keyCode = e.getKeyCode();

    // Defined in InputEvent class.
    int modifiers = e.getModifiers();

    if (keyCode == KeyEvent.VK_A)
      {
	System.out.println("Consuming key...");

	if (e.isShiftDown())
	  e.consume();

	return;
      }

    System.out.println("Key char = " + e.getKeyChar());

    System.out.println("Key code = " + keyCode);
    System.out.println("Key text = " + e.getKeyText(keyCode));

    System.out.println(e.getKeyModifiersText(modifiers));
    System.out.println();
  }
}



